1 #!/bin/sh -- # no runable script, just for vi
5 # we all like colorful messages
6 if [ "$MSGCOLOR" != 'NO' ]; then
7 if ! expr match
"$(readlink -f /proc/$$/fd/1)" '/dev/pts/[0-9]\+' > /dev
/null
; then
13 if [ "$MSGCOLOR" != 'NO' ]; then
14 CERROR
="\033[1;31m" # red
15 CWARNING
="\033[1;33m" # yellow
16 CMSG
="\033[1;32m" # green
17 CINFO
="\033[1;96m" # light blue
18 CDEBUG
="\033[1;94m" # blue
19 CNORMAL
="\033[0;39m" # default system console color
20 CDONE
="\033[1;32m" # green
21 CPASS
="\033[1;32m" # green
22 CFAIL
="\033[1;31m" # red
23 CCMD
="\033[1;35m" # pink
26 msgdie
() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
27 msgwarn
() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
28 msgmsg
() { echo "${CMSG}$1${CNORMAL}"; }
29 msginfo
() { echo "${CINFO}I: $1${CNORMAL}"; }
30 msgdebug
() { echo "${CDEBUG}D: $1${CNORMAL}"; }
31 msgdone
() { echo "${CDONE}DONE${CNORMAL}"; }
32 msgnwarn
() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
33 msgnmsg
() { echo -n "${CMSG}$1${CNORMAL}"; }
34 msgninfo
() { echo -n "${CINFO}I: $1${CNORMAL}"; }
35 msgndebug
() { echo -n "${CDEBUG}D: $1${CNORMAL}"; }
38 echo -n "${CINFO}$1${CCMD} "
39 echo -n "$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} "
41 if [ -n "$1" ]; then shift; else break; fi
43 echo -n "…${CNORMAL} "
45 msgpass
() { echo "${CPASS}PASS${CNORMAL}"; }
46 msgskip
() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
48 if [ $# -gt 0 ]; then echo "${CFAIL}FAIL: $*${CNORMAL}" >&2;
49 else echo "${CFAIL}FAIL${CNORMAL}" >&2; fi
50 EXIT_CODE
=$((EXIT_CODE+1));
53 # enable / disable Debugging
54 MSGLEVEL
=${MSGLEVEL:-3}
55 if [ $MSGLEVEL -le 0 ]; then
58 if [ $MSGLEVEL -le 1 ]; then
62 if [ $MSGLEVEL -le 2 ]; then
66 msgpass
() { echo -n " ${CPASS}P${CNORMAL}"; }
67 msgskip
() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
68 if [ -n "$CFAIL" ]; then
69 msgfail
() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; EXIT_CODE
=$((EXIT_CODE+1)); }
71 msgfail
() { echo -n " ###FAILED###" >&2; EXIT_CODE
=$((EXIT_CODE+1)); }
74 if [ $MSGLEVEL -le 3 ]; then
78 if [ $MSGLEVEL -le 4 ]; then
83 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
84 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
85 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
86 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
87 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
90 echo "${CDONE}DONE${CNORMAL}";
94 if [ -f .
/aptconfig.conf
]; then
95 echo "./aptconfig.conf"
96 elif [ -f ..
/aptconfig.conf
]; then
97 echo "../aptconfig.conf"
101 msgdebug
"Executing: ${CCMD}$*${CDEBUG} "
106 *) CMD
="${BUILDDIRECTORY}/$CMD";;
108 MALLOC_PERTURB_
=21 MALLOC_CHECK_
=2 APT_CONFIG
="$(getaptconfig)" LD_LIBRARY_PATH
=${BUILDDIRECTORY} $CMD "$@"
110 aptconfig
() { runapt apt
-config "$@"; }
111 aptcache
() { runapt apt
-cache "$@"; }
112 aptcdrom
() { runapt apt
-cdrom "$@"; }
113 aptget
() { runapt apt
-get "$@"; }
114 aptftparchive
() { runapt apt
-ftparchive "$@"; }
115 aptkey
() { runapt apt
-key "$@"; }
116 aptmark
() { runapt apt
-mark "$@"; }
117 apt
() { runapt apt
"$@"; }
118 apthelper
() { runapt
"${APTHELPERBINDIR}/apt-helper" "$@"; }
119 aptwebserver
() { runapt
"${APTWEBSERVERBINDIR}/aptwebserver" "$@"; }
120 aptitude
() { runapt aptitude
"$@"; }
121 aptextracttemplates
() { runapt apt
-extracttemplates "$@"; }
124 command dpkg
--root=${TMPWORKINGDIRECTORY}/rootdir
--force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log
"$@"
126 dpkgcheckbuilddeps
() {
127 command dpkg
-checkbuilddeps --admindir=${TMPWORKINGDIRECTORY}/rootdir
/var
/lib
/dpkg
"$@"
131 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${LIBRARYPATH} command gdb
${BUILDDIRECTORY}/$1 --args "$@"
134 # see apt-key for the whole trickery. Setup is done in setupenvironment
135 command gpg
--ignore-time-conflict --no-options --no-default-keyring \
136 --homedir "${TMPWORKINGDIRECTORY}/gnupghome" \
137 --no-auto-check-trustdb --trust-model always \
142 # error if we about to overflow, but ...
143 # "255 failures ought to be enough for everybody"
144 if [ $EXIT_CODE -gt 255 ]; then
145 msgdie
"Total failure count $EXIT_CODE too big"
147 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
150 shellsetedetector
() {
152 if [ "$exit_status" != '0' ]; then
153 echo >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}"
154 if [ "$EXIT_CODE" = '0' ]; then
155 EXIT_CODE
="$exit_status"
161 if [ "$1" = 'prefix' ]; then
162 CURRENTTRAP
="$2 $CURRENTTRAP"
164 CURRENTTRAP
="$CURRENTTRAP $1"
166 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
170 TMPWORKINGDIRECTORY
=$(mktemp -d)
171 TESTDIRECTORY
=$(readlink -f $(dirname $0))
172 msgninfo
"Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
174 # allow overriding the default BUILDDIR location
175 BUILDDIRECTORY
=${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}
176 LIBRARYPATH
=${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"}
177 METHODSDIR
=${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}
178 APTHELPERBINDIR
=${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}
179 APTWEBSERVERBINDIR
=${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}
180 test -x "${BUILDDIRECTORY}/apt-get" || msgdie
"You need to build tree first"
183 addtrap
"cd /; rm -rf $TMPWORKINGDIRECTORY;"
184 cd $TMPWORKINGDIRECTORY
185 mkdir rootdir aptarchive keys
187 mkdir -p etc
/apt
/apt.conf.d etc
/apt
/sources.list.d etc
/apt
/trusted.gpg.d etc
/apt
/preferences.d
188 mkdir -p var
/cache var
/lib
/apt var
/log tmp
189 mkdir -p var
/lib
/dpkg
/info var
/lib
/dpkg
/updates var
/lib
/dpkg
/triggers
190 touch var
/lib
/dpkg
/available
192 ln -s ${METHODSDIR} usr
/lib
/apt
/methods
193 # use the autoremove from the BUILDDIRECTORY if its there, otherwise
195 if [ -e ${BUILDDIRECTORY}/..
/..
/debian
/apt.conf.autoremove
]; then
196 ln -s ${BUILDDIRECTORY}/..
/..
/debian
/apt.conf.autoremove etc
/apt
/apt.conf.d
/01autoremove
198 ln -s /etc
/apt
/apt.conf.d
/01autoremove etc
/apt
/apt.conf.d
/01autoremove
201 local PACKAGESFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
202 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
203 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
205 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
206 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
207 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive
/Sources
209 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys
/
210 ln -s ${TMPWORKINGDIRECTORY}/keys
/joesixpack.pub rootdir
/etc
/apt
/trusted.gpg.d
/joesixpack.gpg
211 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
212 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
213 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
214 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
215 echo "Dir::Bin::Methods \"${METHODSDIR}\";" >> aptconfig.conf
216 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
217 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
218 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
219 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
220 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
221 if ! command dpkg
--assert-multi-arch >/dev
/null
2>&1; then
222 echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf
# Added to test multiarch before dpkg is ready for it…
224 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
225 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
226 echo "Acquire::https::CaInfo \"${TESTDIR}/apt.pem\";" > rootdir
/etc
/apt
/apt.conf.d
/99https
227 echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir
/etc
/apt
/apt.conf.d
/apt
-binary
228 configcompression
'.' 'gz' #'bz2' 'lzma' 'xz'
230 # gpg needs a trustdb to function, but it can't be invalid (not even empty)
231 # see also apt-key where this trickery comes from:
232 local TRUSTDBDIR
="${TMPWORKINGDIRECTORY}/gnupghome"
234 chmod 700 "$TRUSTDBDIR"
235 # We also don't use a secret keyring, of course, but gpg panics and
236 # implodes if there isn't one available - and writeable for imports
237 local SECRETKEYRING
="${TRUSTDBDIR}/secring.gpg"
239 # now create the trustdb with an (empty) dummy keyring
240 # newer gpg versions are fine without it, but play it safe for now
241 gpg
--quiet --check-trustdb --secret-keyring $SECRETKEYRING --keyring $SECRETKEYRING >/dev
/null
2>&1
243 # cleanup the environment a bit
244 # prefer our apt binaries over the system apt binaries
245 export PATH
="${BUILDDIRECTORY}:${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
246 export LC_ALL
=C.UTF
-8
247 unset LANGUAGE APT_CONFIG
248 unset GREP_OPTIONS DEB_BUILD_PROFILES
254 if [ "$1" = "native" -o -z "$1" ]; then
255 eval `aptconfig shell ARCH APT::Architecture`
256 if [ -n "$ARCH" ]; then
259 dpkg
--print-architecture
267 echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
270 getarchitecturesfromcommalist
() {
271 echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/"
274 configarchitecture
() {
276 echo "APT::Architecture \"$(getarchitecture $1)\";"
277 while [ -n "$1" ]; do
278 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
281 } >rootdir
/etc
/apt
/apt.conf.d
/01multiarch.conf
286 if [ ! -e rootdir
/var
/lib
/dpkg
/status
]; then
287 local STATUSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
288 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
289 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
291 echo -n > rootdir/var/lib/dpkg/status
294 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
295 if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then
296 local ARCHS="$(getarchitectures)"
297 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
298 DPKGARCH="$(dpkg --print-architecture)"
299 for ARCH in ${ARCHS}; do
300 if [ "${ARCH}" != "${DPKGARCH}" ]; then
301 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
302 # old-style used e.g. in Ubuntu-P – and as it seems travis
303 echo "DPKG
::options
:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
304 echo "DPKG
::options
:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
308 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
309 # dpkg doesn't really check the version as long as it is fully installed,
310 # but just to be sure we choose one above the required version
311 insertinstalledpackage 'dpkg' "all
" '1.16.2+fake'
317 configcompression() {
318 while [ -n "$1" ]; do
320 '.') echo ".
\t.
\tcat
";;
321 'gz') echo "gzip\tgz
\tgzip
";;
322 'bz2') echo "bzip2\tbz
2\tbzip
2";;
323 'lzma') echo "lzma
\tlzma
\txz
--format=lzma
";;
324 'xz') echo "xz
\txz
\txz
";;
325 *) echo "$1\t$1\t$1";;
328 done > ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf
331 setupsimplenativepackage() {
335 local RELEASE="${4:-unstable}"
336 local DEPENDENCIES="$5"
337 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
338 If you
find such a package installed on your system
,
339 something went horribly wrong
! They are autogenerated
340 und used only by testcases and surf no other propose…
"}"
342 local SECTION
="${7:-others}"
344 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
347 DISTSECTION
="$(echo "$SECTION" | cut -d'/' -f 1)"
349 local BUILDDIR
=incoming
/${NAME}-${VERSION}
350 mkdir -p ${BUILDDIR}/debian
/source
352 echo "* most suckless software product ever" > FEATURES
353 test -e debian
/copyright
|| echo "Copyleft by Joe Sixpack $(date +%Y)" > debian
/copyright
354 test -e debian
/changelog
|| echo "$NAME ($VERSION) $RELEASE; urgency=low
358 -- Joe Sixpack <joe@example.org> $(date -R)" > debian
/changelog
359 test -e debian
/control
|| echo "Source: $NAME
362 Maintainer: Joe Sixpack <joe@example.org>
363 Build-Depends: debhelper (>= 7)
364 Standards-Version: 3.9.1
366 Package: $NAME" > debian
/control
367 if [ "$ARCH" = 'all' ]; then
368 echo "Architecture: all" >> debian
/control
370 echo "Architecture: any" >> debian
/control
372 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian
/control
373 echo "Description: $DESCRIPTION" >> debian
/control
375 test -e debian
/compat
|| echo "7" > debian
/compat
376 test -e debian
/source
/format
|| echo "3.0 (native)" > debian
/source
/format
377 test -e debian
/rules
|| cp /usr
/share
/doc
/debhelper
/examples
/rules.tiny debian
/rules
381 buildsimplenativepackage
() {
385 local RELEASE
="${4:-unstable}"
386 local DEPENDENCIES
="$5"
387 local DESCRIPTION
="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
388 If you find such a package installed on your system,
389 something went horribly wrong! They are autogenerated
390 und used only by testcases and surf no other propose…"}"
392 local SECTION="${7:-others}"
393 local PRIORITY="${8:-optional}"
395 local COMPRESS_TYPE="${10:-gzip}"
397 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
400 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
402 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
404 msgninfo "Build package
${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}…
"
405 mkdir -p $BUILDDIR/debian/source
406 echo "* most suckless software product ever
" > ${BUILDDIR}/FEATURES
408 echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
410 echo "Copyleft by Joe Sixpack
$(date +%Y)" > ${BUILDDIR}/debian/copyright
411 echo "$NAME ($VERSION) $RELEASE; urgency
=low
415 -- Joe Sixpack
<joe@example.org
> $(date -R)" > ${BUILDDIR}/debian/changelog
419 Maintainer
: Joe Sixpack
<joe@example.org
>
420 Standards
-Version: 3.9.3" > ${BUILDDIR}/debian/control
421 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
422 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
424 Package
: $NAME" >> ${BUILDDIR}/debian/control
426 if [ "$ARCH" = 'all' ]; then
427 echo "Architecture
: all
" >> ${BUILDDIR}/debian/control
429 echo "Architecture
: any
" >> ${BUILDDIR}/debian/control
431 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
432 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
433 echo "Description
: $DESCRIPTION" >> ${BUILDDIR}/debian/control
435 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
436 (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' \
438 echo "pool
/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
439 # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
440 # gpg --yes --secret-keyring ./keys/joesixpack.sec \
441 # --keyring ./keys/joesixpack.pub --default-key 'Joe Sixpack' \
442 # --clearsign -o "${BUILDDIR}/..
/${SRC}.sign
" "${BUILDDIR}/..
/$SRC"
443 # mv "${BUILDDIR}/..
/${SRC}.sign
" "${BUILDDIR}/..
/$SRC"
447 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
448 rm -rf ${BUILDDIR}/debian/tmp
449 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
450 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
451 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
452 if [ -n "$FILE_TREE" ]; then
453 cp -ar "$FILE_TREE" ${BUILDDIR}/debian/tmp
456 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
457 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
458 local LOG="${BUILDDIR}/..
/${NAME}_
${VERSION}_
${arch}.dpkg
-deb.log
"
459 # ensure the right permissions as dpkg-deb ensists
460 chmod 755 ${BUILDDIR}/debian/tmp/DEBIAN
461 if ! dpkg-deb -Z${COMPRESS_TYPE} --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. >$LOG 2>&1; then
466 echo "pool
/${NAME}_
${VERSION}_
${arch}.deb
" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
469 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
470 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
471 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
480 local ARCH=$(getarchitecture $4)
481 local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')"
482 local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")"
483 msgninfo "Build package
${PKGNAME} for ${RELEASE} in ${SECTION}…
"
485 if [ "$ARCH" = "all
" ]; then
486 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
488 if ! dpkg-buildpackage -uc -us -a$ARCH >$BUILDLOG 2>&1 ; then
492 local PKGS="$(grep '^dpkg-deb: building package' $BUILDLOG | cut -d'/' -f 2 | sed -e "s#'\.##")"
493 local SRCS="$(grep '^dpkg-source: info: building' $BUILDLOG | grep -o '[a-z0-9._+~-]*$')"
496 echo "pool
/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
499 echo "pool
/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
505 if [ -d incoming ]; then
506 buildaptarchivefromincoming "$@
"
508 buildaptarchivefromfiles "$@
"
512 createaptftparchiveconfig() {
513 local COMPRESSORS="$(cut -d' ' -f 1 ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | tr '\n' ' ')"
514 COMPRESSORS="${COMPRESSORS%* }"
515 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb
$#\
1#' | tr '\n' ' ')"
516 if [ -z "$ARCHS" ]; then
517 # the pool is empty, so we will operate on faked packages - let us use the configured archs
518 ARCHS
="$(getarchitectures)"
521 ArchiveDir "' >> ftparchive.conf
522 echo -n $(readlink -f .) >> ftparchive.conf
524 CacheDir "' >> ftparchive.conf
525 echo -n $(readlink -f ..) >> ftparchive.conf
527 FileListDir "' >> ftparchive.conf
528 echo -n $(readlink -f pool/) >> ftparchive.conf
532 Packages::Compress "'"$COMPRESSORS"'";
533 Sources::Compress "'"$COMPRESSORS"'";
534 Contents::Compress "'"$COMPRESSORS"'";
535 Translation::Compress "'"$COMPRESSORS"'";
536 LongDescription "false";
540 SrcDirectory "pool/";
546 Label "apttestcases";
548 Description "repository with dummy packages";
549 Architectures "' >> ftparchive.conf
550 echo -n "$ARCHS" >> ftparchive.conf
554 };' >> ftparchive.conf
555 for DIST
in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
556 echo -n 'tree "dists/' >> ftparchive.conf
557 echo -n "$DIST" >> ftparchive.conf
559 Architectures "' >> ftparchive.conf
560 echo -n "$ARCHS" >> ftparchive.conf
562 FileList "' >> ftparchive.conf
563 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
565 SourceFileList "' >> ftparchive.conf
566 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
568 Sections "' >> ftparchive.conf
569 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
571 };' >> ftparchive.conf
575 buildaptftparchivedirectorystructure
() {
576 local DISTS
="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
577 for DIST
in $DISTS; do
578 local SECTIONS
="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
579 for SECTION
in $SECTIONS; do
580 local ARCHS
="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
581 for ARCH
in $ARCHS; do
582 mkdir -p dists
/${DIST}/${SECTION}/binary
-${ARCH}
584 mkdir -p dists
/${DIST}/${SECTION}/source
585 mkdir -p dists
/${DIST}/${SECTION}/i18n
595 local DEPENDENCIES
="$5"
596 local PRIORITY
="${6:-optional}"
597 local DESCRIPTION
="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
598 If you find such a package installed on your system,
599 something went horribly wrong! They are autogenerated
600 und used only by testcases and surf no other propose…"}"
602 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
603 if [ "$arch" = 'all' -o "$arch" = 'none' ]; then
604 ARCHS="$(getarchitectures)"
608 for BUILDARCH in $ARCHS; do
609 local PPATH="aptarchive
/dists
/${RELEASE}/main
/binary
-${BUILDARCH}"
610 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
611 touch aptarchive/dists/${RELEASE}/main/source/Sources
612 local FILE="${PPATH}/Packages
"
617 Maintainer
: Joe Sixpack
<joe@example.org
>" >> $FILE
618 test "$arch" = 'none' || echo "Architecture
: $arch" >> $FILE
619 echo "Version
: $VERSION
620 Filename
: pool
/main
/${NAME}/${NAME}_
${VERSION}_
${arch}.deb
" >> $FILE
621 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
622 echo "Description
: $DESCRIPTION" >> $FILE
633 local DEPENDENCIES="$5"
635 local SPATH="aptarchive
/dists
/${RELEASE}/main
/source"
637 local FILE="${SPATH}/Sources
"
641 Maintainer
: Joe Sixpack
<joe@example.org
>
642 Architecture
: $ARCH" >> $FILE
643 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
645 d41d8cd98f00b204e9800998ecf8427e
0 ${NAME}_
${VERSION}.dsc
646 d41d8cd98f00b204e9800998ecf8427e
0 ${NAME}_
${VERSION}.
tar.gz
650 insertinstalledpackage() {
654 local DEPENDENCIES="$4"
655 local PRIORITY="${5:-optional}"
656 local STATUS="${6:-install ok installed}"
657 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed
658 If you
find such a package installed on your system
,
659 something went horribly wrong
! They are autogenerated
660 und used only by testcases and surf no other propose…
"}"
662 local FILE
='rootdir/var/lib/dpkg/status'
663 local INFO
='rootdir/var/lib/dpkg/info'
664 for arch
in $(getarchitecturesfromcommalist "$ARCH"); do
670 Maintainer: Joe Sixpack <joe@example.org>
671 Version: $VERSION" >> $FILE
672 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
673 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
674 echo "Description: $DESCRIPTION" >> $FILE
676 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
677 echo -n > ${INFO}/${NAME}:${arch}.list
679 echo -n > ${INFO}/${NAME}.list
685 buildaptarchivefromincoming
() {
686 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
688 [ -e pool
] || ln -s ..
/incoming pool
689 [ -e ftparchive.conf
] || createaptftparchiveconfig
690 [ -e dists
] || buildaptftparchivedirectorystructure
691 msgninfo
"\tGenerate Packages, Sources and Contents files… "
692 aptftparchive
-qq generate ftparchive.conf
698 buildaptarchivefromfiles
() {
699 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
700 find aptarchive
-name 'Packages' -o -name 'Sources' | while read line
; do
701 msgninfo
"\t${line} file… "
702 compressfile
"$line" "$1"
705 generatereleasefiles
"$@"
709 cat ${TMPWORKINGDIRECTORY}/rootdir
/etc
/testcase
-compressor.conf
| while read compressor extension
command; do
710 if [ "$compressor" = '.' ]; then
716 cat "$1" | $command > "${1}.${extension}"
718 touch -d "$2" "${1}.${extension}"
723 # can be overridden by testcases for their pleasure
724 getcodenamefromsuite
() {
726 unstable
) echo 'sid';;
730 getreleaseversionfromsuite
() { true
; }
731 getlabelfromsuite
() { true
; }
733 generatereleasefiles
() {
734 # $1 is the Date header and $2 is the ValidUntil header to be set
735 # both should be given in notation date/touch can understand
736 msgninfo
"\tGenerate Release files… "
737 if [ -e aptarchive
/dists
]; then
738 for dir
in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
739 local SUITE
="$(echo "$dir" | cut -d'/' -f 4)"
740 local CODENAME
="$(getcodenamefromsuite $SUITE)"
741 local VERSION
="$(getreleaseversionfromsuite $SUITE)"
742 local LABEL
="$(getlabelfromsuite $SUITE)"
743 if [ -n "$VERSION" ]; then
744 VERSION
="-o APT::FTPArchive::Release::Version=${VERSION}"
746 if [ -n "$LABEL" ]; then
747 LABEL
="-o APT::FTPArchive::Release::Label=${LABEL}"
749 aptftparchive
-qq release
$dir \
750 -o APT
::FTPArchive
::Release
::Suite
="${SUITE}" \
751 -o APT
::FTPArchive
::Release
::Codename
="${CODENAME}" \
754 | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
755 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
757 NotAutomatic: yes' $dir/Release
759 if [ -n "$1" -a "$1" != "now" ]; then
760 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
764 Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
768 aptftparchive
-qq release .
/aptarchive
| sed -e '/0 Release$/ d' > aptarchive
/Release
# remove the self reference
770 if [ -n "$1" -a "$1" != "now" ]; then
771 for release
in $(find ./aptarchive -name 'Release'); do
772 touch -d "$1" $release
778 setupdistsaptarchive
() {
779 local APTARCHIVE
=$(readlink -f ./aptarchive)
780 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb.list
781 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb-src.list
782 for DISTS
in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
783 SECTIONS
=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
784 msgninfo
"\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
785 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb.list
786 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb-src.list
791 setupflataptarchive
() {
792 local APTARCHIVE
=$(readlink -f ./aptarchive)
793 if [ -f ${APTARCHIVE}/Packages
]; then
794 msgninfo
"\tadd deb sources.list line… "
795 echo "deb file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
798 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
800 if [ -f ${APTARCHIVE}/Sources
]; then
801 msgninfo
"\tadd deb-src sources.list line… "
802 echo "deb-src file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
805 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
811 if [ -e aptarchive
/dists
]; then
817 if [ "$1" != '--no-update' ]; then
818 msgninfo
"\tSync APT's cache with the archive… "
825 local SIGNER
="${1:-Joe Sixpack}"
826 local GPG
="gpg --batch --yes"
827 msgninfo
"\tSign archive with $SIGNER key… "
828 local REXKEY
='keys/rexexpired'
829 local SECEXPIREBAK
="${REXKEY}.sec.bak"
830 local PUBEXPIREBAK
="${REXKEY}.pub.bak"
831 if [ "${SIGNER}" = 'Rex Expired' ]; then
832 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
833 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
834 # therefore we 'temporary' make the key not expired and restore a backup after signing
835 cp ${REXKEY}.sec
$SECEXPIREBAK
836 cp ${REXKEY}.pub
$PUBEXPIREBAK
837 local SECUNEXPIRED
="${REXKEY}.sec.unexpired"
838 local PUBUNEXPIRED
="${REXKEY}.pub.unexpired"
839 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
840 cp $SECUNEXPIRED ${REXKEY}.sec
841 cp $PUBUNEXPIRED ${REXKEY}.pub
843 printf "expire\n1w\nsave\n" | $GPG --keyring ${REXKEY}.pub
--secret-keyring ${REXKEY}.sec
--command-fd 0 --edit-key "${SIGNER}" >/dev
/null
2>&1 || true
844 cp ${REXKEY}.sec
$SECUNEXPIRED
845 cp ${REXKEY}.pub
$PUBUNEXPIRED
848 for KEY
in $(find keys/ -name '*.sec'); do
849 GPG
="$GPG --secret-keyring $KEY"
851 for KEY
in $(find keys/ -name '*.pub'); do
852 GPG
="$GPG --keyring $KEY"
854 for RELEASE
in $(find aptarchive/ -name Release); do
855 $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output ${RELEASE}.gpg
${RELEASE}
856 local INRELEASE
="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')"
857 $GPG --default-key "$SIGNER" --clearsign --output $INRELEASE $RELEASE
858 # we might have set a specific date for the Release file, so copy it
859 touch -d "$(stat --format "%y" ${RELEASE})" ${RELEASE}.gpg
${INRELEASE}
861 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
862 mv -f $SECEXPIREBAK ${REXKEY}.sec
863 mv -f $PUBEXPIREBAK ${REXKEY}.pub
869 msgtest
"Set webserver config option '${1}' to" "$2"
870 local DOWNLOG
='rootdir/tmp/download-testfile.log'
871 local STATUS
='rootdir/tmp/webserverconfig.status'
872 rm -f "$STATUS" "$DOWNLOG"
873 if downloadfile
"http://localhost:8080/_config/set/${1}/${2}" "$STATUS" > "$DOWNLOG"; then
876 cat "$DOWNLOG" "$STATUS"
879 testwebserverlaststatuscode
'200'
882 rewritesourceslist
() {
883 local APTARCHIVE
="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive")"
884 for LIST
in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
885 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#http://localhost:8080/#${1}#" -e "s#http://localhost:4433/#${1}#"
889 # wait for up to 10s for a pid file to appear to avoid possible race
890 # when a helper is started and dosn't write the PID quick enough
893 for i
in $(seq 10); do
894 if test -s "$PIDFILE"; then
899 msgdie
"waiting for $PIDFILE failed"
903 changetowebserver
() {
904 if [ "$1" != '--no-rewrite' ]; then
905 rewritesourceslist
'http://localhost:8080/'
909 if test -x ${APTWEBSERVERBINDIR}/aptwebserver
; then
911 local LOG
="webserver.log"
912 if ! aptwebserver
-o aptwebserver
::fork
=1 "$@" >$LOG 2>&1 ; then
916 waitforpidfile aptwebserver.pid
917 local PID
="$(cat aptwebserver.pid)"
918 if [ -z "$PID" ]; then
919 msgdie
'Could not fork aptwebserver successfully'
924 msgdie
'You have to build aptwerbserver or install a webserver'
928 changetohttpswebserver
() {
929 if ! which stunnel4
>/dev
/null
; then
930 msgdie
'You need to install stunnel4 for https testcases'
932 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
933 changetowebserver
--no-rewrite "$@"
935 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
936 cert = ${TESTDIRECTORY}/apt.pem
942 " > ${TMPWORKINGDIRECTORY}/stunnel.conf
943 stunnel4
"${TMPWORKINGDIRECTORY}/stunnel.conf"
944 waitforpidfile
"${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid"
945 local PID
="$(cat ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid)"
946 if [ -z "$PID" ]; then
947 msgdie
'Could not fork stunnel4 successfully'
949 addtrap
'prefix' "kill ${PID};"
950 rewritesourceslist
'https://localhost:4433/'
954 mkdir -p rootdir
/media
/cdrom
/.disk
955 local CD
="$(readlink -f rootdir/media/cdrom)"
956 echo "acquire::cdrom::mount \"${CD}\";
957 acquire::cdrom::${CD}/::mount \"mv ${CD}-unmounted ${CD}\";
958 acquire::cdrom::${CD}/::umount \"mv ${CD} ${CD}-unmounted\";
959 acquire::cdrom::autodetect 0;" > rootdir
/etc
/apt
/apt.conf.d
/00cdrom
960 echo -n "$1" > ${CD}/.disk
/info
961 if [ ! -d aptarchive
/dists
]; then
962 msgdie
'Flat file archive cdroms can not be created currently'
965 mv aptarchive
/dists
"$CD"
966 ln -s "$(readlink -f ./incoming)" $CD/pool
967 find rootdir
/etc
/apt
/sources.list.d
/ -name 'apt-test-*.list' -delete
968 # start with an unmounted disk
969 mv "${CD}" "${CD}-unmounted"
970 # we don't want the disk to be modifiable
971 addtrap
'prefix' "chmod -f -R +w $PWD/rootdir/media/cdrom/dists/ $PWD/rootdir/media/cdrom-unmounted/dists/ || true;"
972 chmod -R -w rootdir
/media
/cdrom
-unmounted/dists
976 local PROTO
="$(echo "$1" | cut -d':' -f 1 )"
977 apthelper
-o Debug
::Acquire
::${PROTO}=1 \
978 download
-file "$1" "$2" 2>&1 || true
979 # only if the file exists the download was successful
988 local DIFFTEXT
="$(command diff -u "$@" | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
989 if [ -n "$DIFFTEXT" ]; then
1001 msgtest
"Test for correctness of file" "$FILE"
1002 if [ -z "$*" ]; then
1003 echo -n "" | checkdiff
$FILE - && msgpass
|| msgfail
1005 echo "$*" | checkdiff
$FILE - && msgpass
|| msgfail
1010 msgtest
"Test for no output of" "$*"
1011 test -z "$($* 2>&1)" && msgpass
|| msgfail
1015 local MSG
='Test of equality of'
1016 if [ "$1" = '--nomsg' ]; then
1021 local COMPAREFILE
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile"
1022 echo "$1" > $COMPAREFILE
1025 if [ -n "$MSG" ]; then
1028 $
* 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
1032 local COMPAREFILE1
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
1033 local COMPAREFILE2
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
1034 local COMPAREAGAINST
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
1035 echo "$1" > $COMPAREFILE1
1036 echo "$2" > $COMPAREFILE2
1038 msgtest
"Test for equality OR of" "$*"
1039 $
* >$COMPAREAGAINST 2>&1 || true
1040 if checkdiff
$COMPAREFILE1 $COMPAREAGAINST >/dev
/null
2>&1 || \
1041 checkdiff
$COMPAREFILE2 $COMPAREAGAINST >/dev
/null
2>&1
1045 echo -n "\n${CINFO}Diff against OR 1${CNORMAL}"
1046 checkdiff
$COMPAREFILE1 $COMPAREAGAINST || true
1047 echo -n "${CINFO}Diff against OR 2${CNORMAL}"
1048 checkdiff
$COMPAREFILE2 $COMPAREAGAINST || true
1054 local VIRTUAL
="N: Can't select versions from package '$1' as it is purely virtual"
1057 while [ -n "$1" ]; do
1059 N: Can't select versions from package '$1' as it is purely virtual"
1060 PACKAGE
="${PACKAGE} $1"
1063 msgtest
"Test for virtual packages" "apt-cache show $PACKAGE"
1065 N: No packages found"
1066 local COMPAREFILE
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
1067 local ARCH
="$(getarchitecture 'native')"
1068 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
1069 aptcache show
-q=0 $PACKAGE 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
1073 msgtest
"Test for non-existent packages" "apt-cache show $*"
1074 local SHOWPKG
="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
1075 if [ -n "$SHOWPKG" ]; then
1084 testdpkginstalled
() {
1085 msgtest
"Test for correctly installed package(s) with" "dpkg -l $*"
1086 local PKGS
="$(dpkg -l "$@" 2>/dev/null | grep '^i' | wc -l)"
1087 if [ "$PKGS" != $# ]; then
1089 dpkg
-l "$@" | grep '^[a-z]' >&2
1096 testdpkgnotinstalled
() {
1097 msgtest
"Test for correctly not-installed package(s) with" "dpkg -l $*"
1098 local PKGS
="$(dpkg -l "$@" 2> /dev/null | grep '^i' | wc -l)"
1099 if [ "$PKGS" != 0 ]; then
1101 dpkg
-l "$@" | grep '^[a-z]' >&2
1109 local COMPAREFILE
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
1110 if [ -n "$1" ]; then
1111 msgtest
'Test for correctly marked as auto-installed' "$*"
1112 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
1114 msgtest
'Test for correctly marked as auto-installed' 'no package'
1115 echo -n > $COMPAREFILE
1117 aptmark showauto
2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
1121 if [ "$1" = '--nomsg' ]; then
1124 msgtest
'Test for successful execution of' "$*"
1126 local OUTPUT
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output"
1127 if $@
>${OUTPUT} 2>&1; then
1137 if [ "$1" = '--nomsg' ]; then
1140 msgtest
'Test for failure in execution of' "$*"
1142 local OUTPUT
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
1143 if $@
>${OUTPUT} 2>&1; then
1152 testwebserverlaststatuscode
() {
1153 local DOWNLOG
='rootdir/tmp/webserverstatus-testfile.log'
1154 local STATUS
='rootdir/tmp/webserverstatus-statusfile.log'
1155 rm -f "$DOWNLOG" "$STATUS"
1156 msgtest
'Test last status code from the webserver was' "$1"
1157 downloadfile
"http://localhost:8080/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG"
1158 if [ "$(cat "$STATUS")" = "$1" ]; then
1162 if [ -n "$2" ]; then
1164 echo >&2 '#### Additionally provided output files contain:'
1167 echo >&2 '#### Download log of the status code:'
1169 msgfail
"Status was $(cat "$STATUS")"
1174 echo "STOPPED execution. Press enter to continue"